<?php
/**
 * Widgets Functions
 *
 * @since 1.0.0
 */

// PAGINATION FUNCTION //
function woocommerceproductsrevolutiondisplay_elementor_pagination($num_page_for_pagination,$pagination) {
	$output = '<ul class="fg_pagination">';
	for($i=1; $i <= $num_page_for_pagination; $i++) {

		if($i == $pagination) {
			$output .= '<li class="fg_current">'.esc_html($i).'</li>'; // CURRENT PAGE
		} else {
			$output .= '<li><a href="'.get_post_permalink().'&fg_page='.$i.'">'.esc_html($i).'</a></li>'; // OTHER PAGE
		}
	}
	$output .= '</ul>';
	return $output;
}

// HEX FUNCTION
function woocommerceproductsrevolutiondisplay_elementor_hex2rgb($hex) {

   $hex = str_replace("#", "", $hex);

if(strlen($hex) == 3) {
		$r = hexdec(substr($hex,0,1).substr($hex,0,1));
		$g = hexdec(substr($hex,1,1).substr($hex,1,1));
		$b = hexdec(substr($hex,2,1).substr($hex,2,1));
	} else {
		$r = hexdec(substr($hex,0,2));
		$g = hexdec(substr($hex,2,2));
		$b = hexdec(substr($hex,4,2));
	}
	$rgb = array($r, $g, $b);
	return $rgb;
}

function woocommerceproductsrevolutiondisplay_elementor_photoswipe_style($rgba_main_color,
						  $fg_main_color,
						  $fg_secondary_color,
						  $rgba_secondary_color,
						  $fg_pagination_active,
						  $fg_spacing_active,
						  $fg_spacing,
						  $fg_image_lightbox,
						  $selector,
						  $fg_gallery_name_font_size,
						  $fg_gallery_name_font_color,
						  $fg_gallery_name_text_align,
						  $float,
						  $itemwidth,
						  $fg_gallery_name_show
						  ) {


				$gallery_style = "
				<style type='text/css'>
					#{$selector} {
					margin: auto;
					}
					#{$selector} .fg-gallery-item {
					float: {$float};
					margin-top: 10px;
					text-align: center;
					width: {$itemwidth}%;
					}
					#{$selector} .fg-gallery-caption {
					margin-left: 0;
					}
					#{$selector}.woocommerceproductsrevolutiondisplay .fg-gallery-caption,
					#{$selector}.woocommerceproductsrevolutiondisplay .fg-gallery-caption:hover {
						background-color:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style1 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style2 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a {
						background:".$rgba_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style2 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style3 .fg_zoom,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style3 .fg_zoom:hover {
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style3 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style4 .fg-gallery-caption,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style4 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style4 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style4 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style4 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style4 .fg-photoswipe .woocommerceproductsrevolutiondisplay-mask	{
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style5 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style5 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style5 .fg-photoswipe .woocommerceproductsrevolutiondisplay-mask	{
						background-color:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style6 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style6 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_secondary_color.";
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style6 .fg-photoswipe .woocommerceproductsrevolutiondisplay-mask	{
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style6 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style7 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style7 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_secondary_color.";
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style7 .fg-photoswipe .woocommerceproductsrevolutiondisplay-mask	{
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style7 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}

					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style8 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style8 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_secondary_color.";
						background:".$rgba_main_color.";
					}

					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style8 .fg-photoswipe .woocommerceproductsrevolutiondisplay-mask	{
						background:".$rgba_main_color.";
					}

					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style8 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}

					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style9 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style9 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style9 .fg-photoswipe .woocommerceproductsrevolutiondisplay-mask	{
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style9 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}

					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style10 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style10 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_secondary_color.";
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.gallery.fg_style10 .fg-photoswipe .woocommerceproductsrevolutiondisplay-mask	{
						background:".$rgba_main_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style10 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style11 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style11 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style11 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_main_color.";
						background:".$rgba_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style12 .fg-gallery-caption {
						color:".$fg_secondary_color.";
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style12 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a,
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_style12 .woocommerceproductsrevolutiondisplay-gallery-icon.fg_zoom a:hover {
						color:".$fg_main_color.";
						background:".$rgba_secondary_color.";
					}
					/* THUMBS ONE ON */
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_thumbs_one .fg-gallery-item {
						display:none;
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_thumbs_one .fg-gallery-item:first-child {
						display:block;
					}
					#{$selector}.woocommerceproductsrevolutiondisplay.fg_thumbs_one {
						width:auto!important;
					}
				";

				if($fg_pagination_active == 'on') {
					$gallery_style .= "
						#{$selector}.woocommerceproductsrevolutiondisplay.fg_pagination_style1 ul.fg_pagination li a {
							background:".$rgba_main_color.";
							color:".$fg_secondary_color.";
						}
						#{$selector}.woocommerceproductsrevolutiondisplay.fg_pagination_style1 ul.fg_pagination li a:hover {
							background:".$fg_secondary_color.";
							color:".$rgba_main_color.";
						}
						#{$selector}.woocommerceproductsrevolutiondisplay.fg_pagination_style1 ul.fg_pagination li.fg_current {
							background:".$fg_secondary_color.";
							color:".$rgba_main_color.";
						}
						#{$selector}.woocommerceproductsrevolutiondisplay.fg_pagination_style2 ul.fg_pagination li a {
							color:".$fg_secondary_color.";
						}
						#{$selector}.woocommerceproductsrevolutiondisplay.fg_pagination_style2 ul.fg_pagination li a:hover {
							color:".$rgba_main_color.";
						}
						#{$selector}.woocommerceproductsrevolutiondisplay.fg_pagination_style2 ul.fg_pagination li.fg_current {
							color:".$rgba_main_color.";
						}
					";
				}




				if($fg_spacing_active == 'on') {
					$gallery_style .= "
						.woocommerceproductsrevolutiondisplay.gallery {
							width:100%;
							width: -webkit-calc(100% + ".$fg_spacing."px);
							width: calc(100% + ".$fg_spacing."px);
							/*margin-left:".$fg_spacing."px;*/
						}
						.woocommerceproductsrevolutiondisplay .fg-gallery-item {
							margin-right:".$fg_spacing."px!important;
							margin-bottom:".$fg_spacing."px!important;
						}
						.woocommerceproductsrevolutiondisplay.gallery-columns-2 .fg-gallery-item {
							max-width: 48%;
							max-width: -webkit-calc(50% - ".$fg_spacing."px);
							max-width:         calc(50% - ".$fg_spacing."px);
						}

						.woocommerceproductsrevolutiondisplay.gallery-columns-3 .fg-gallery-item {
							max-width: 32%;
							max-width: -webkit-calc(33.3% - ".$fg_spacing."px);
							max-width:         calc(33.3% - ".$fg_spacing."px);
						}

						.woocommerceproductsrevolutiondisplay.gallery-columns-4 .fg-gallery-item {
							max-width: 23%;
							max-width: -webkit-calc(25% - ".$fg_spacing."px);
							max-width:         calc(25% - ".$fg_spacing."px);
						}

						.woocommerceproductsrevolutiondisplay.gallery-columns-5 .fg-gallery-item {
							max-width: 19%;
							max-width: -webkit-calc(20% - ".$fg_spacing."px);
							max-width:         calc(20% - ".$fg_spacing."px);
						}

						.woocommerceproductsrevolutiondisplay.gallery-columns-6 .fg-gallery-item {
							max-width: 15%;
							max-width: -webkit-calc(16.7% - ".$fg_spacing."px);
							max-width:         calc(16.7% - ".$fg_spacing."px);
						}

						.woocommerceproductsrevolutiondisplay.gallery-columns-7 .fg-gallery-item {
							max-width: 13%;
							max-width: -webkit-calc(14.28% - ".$fg_spacing."px);
							max-width:         calc(14.28% - ".$fg_spacing."px);
						}

						.woocommerceproductsrevolutiondisplay.gallery-columns-8 .fg-gallery-item {
							max-width: 11%;
							max-width: -webkit-calc(12.5% - ".$fg_spacing."px);
							max-width:         calc(12.5% - ".$fg_spacing."px);
						}

						.woocommerceproductsrevolutiondisplay.gallery-columns-9 .fg-gallery-item {
							max-width: 9%;
							max-width: -webkit-calc(11.1% - ".$fg_spacing."px);
							max-width:         calc(11.1% - ".$fg_spacing."px);
						}
					";
				}

				if($fg_image_lightbox == 'zoomin') {
					$gallery_style .= '#'.$selector.'.woocommerceproductsrevolutiondisplay .icon-plus:before {
										content: "\e6ef"!important;
					}';
				}
				if($fg_image_lightbox == 'image') {
					$gallery_style .= '#'.$selector.'.woocommerceproductsrevolutiondisplay .icon-plus:before {
										content: "\e687"!important;
					}';
				}
				if($fg_image_lightbox == 'images') {
					$gallery_style .= '#'.$selector.'.woocommerceproductsrevolutiondisplay .icon-plus:before {
										content: "\e605"!important;
					}';
				}
				if($fg_image_lightbox == 'spinner_icon') {
					$gallery_style .= '#'.$selector.'.woocommerceproductsrevolutiondisplay .icon-plus:before {
										content: "\e6e7"!important;
					}';
				}
				if($fg_image_lightbox == 'search_icon') {
					$gallery_style .= '#'.$selector.'.woocommerceproductsrevolutiondisplay .icon-plus:before {
										content: "\e6ee"!important;
					}';
				}

				if($fg_gallery_name_show == 'true') {
					$gallery_style .= ".fg_gallery_title-{$instance}.fg_gallery_name {
							font-size:".$fg_gallery_name_font_size."px;
							color:".$fg_gallery_name_font_color.";
							text-align:".$fg_gallery_name_text_align.";
					}";
				}

				$gallery_style .= "</style>";


				return $gallery_style;

}

if(!function_exists('woocommerceproductsrevolutiondisplay_query')) {
	function woocommerceproductsrevolutiondisplay_query( $source,
						$posts_source,
						$posts_type,
						$categories,
						$categories_post_type,
						$order,
						$orderby,
						$pagination,
						$pagination_type,
						$num_posts,
						$num_posts_page) {

						if($orderby == 'views') {
								$orderby = 'meta_value_num';
								$view_order = 'views';
						} else { $view_order = ''; }

						if($source == 'post_type') {
							$posts_source = 'all_posts';
						}

						if($posts_source == 'all_posts') {

							$query = 'post_type=Post&post_status=publish&ignore_sticky_posts=1&orderby='.$orderby.'&order='.$order.'';

							// CUSTOM POST TYPE
							if($source == 'post_type') {
								$query .= '&post_type='.$posts_type.'';
							}

							if($view_order == 'views') {
								$query .= '&meta_key=wpb_post_views_count';
							}

							// CATEGORIES POST TYPE
							if($categories_post_type != '' && !empty($categories_post_type) && $source == 'post_type' && $posts_type != 'product') {
								$taxonomy_names = get_object_taxonomies( $posts_type );
								$query .= '&'.$taxonomy_names[0].'='.$categories_post_type.'';
							}

							// WOOCOMMERCE CATEGORIES POST TYPE
							if($categories_post_type != '' && !empty($categories_post_type) && $source == 'post_type' && $posts_type == 'product') {
								$taxonomy_names = get_object_taxonomies( $posts_type );
								$query .= '&'.$taxonomy_names[2].'='.$categories_post_type.'';
							}

							// CATEGORIES POSTS
							if($categories != '' && $categories != 'all' && !empty($categories) && $source == 'wp_posts') {
								$query .= '&category_name='.$categories.'';
							}
							if($pagination == 'yes' || $pagination == 'load-more') {
								$query .= '&posts_per_page='.$num_posts_page.'';
							} else {
								if($num_posts == '') { $num_posts = '-1'; }
								$query .= '&posts_per_page='.$num_posts.'';
							}

							// PAGINATION
							if($pagination == 'yes' || $pagination == 'load-more') {
								if ( get_query_var('paged') ) {
									$paged = get_query_var('paged');

								} elseif ( get_query_var('page') ) {
									$paged = get_query_var('page');
								} else {
									$paged = 1;
								}
								$query .= '&paged='.$paged.'';
							}
							// #PAGINATION

						} else { // IF STICKY


							if($pagination == 'yes' || $pagination == 'load-more') {
								$num_posts = $num_posts_page;
							} else {
								if($num_posts == '') { $num_posts = '-1'; }
								$num_posts = $num_posts;
							}

							// PAGINATION

							if ( get_query_var('paged') ) {
								$paged = get_query_var('paged');
							} elseif ( get_query_var('page') ) {
								$paged = get_query_var('page');
							} else {
								$paged = 1;
							}

							// #PAGINATION

							/* STICKY POST DA FARE ARRAY PER SCRITTURA IN ARRAY */

							$sticky = get_option( 'sticky_posts' );
							$sticky = array_slice( $sticky, 0, 5 );
							if($view_order == 'views') {
								$query = array(
									'post_type' => 'post',
									'post_status' => 'publish',
									'orderby' 	=> $orderby,
									'order' => $order,
									'category_name' => $categories,
									'posts_per_page' => $num_posts,
									'meta_key' => 'wpb_post_views_count',
									'paged' => $paged,
									'post__in'  => $sticky,
									'ignore_sticky_posts' => 1
								);
							} else {
								$query = array(
									'post_type' => 'post',
									'post_status' => 'publish',
									'orderby' 	=> $orderby,
									'order' => $order,
									'category_name' => $categories,
									'posts_per_page' => $num_posts,
									'paged' => $paged,
									'post__in'  => $sticky,
									'ignore_sticky_posts' => 1
								);
							}

						} // #all_posts

						return $query;
	}
}
?>
